require "import"
import "android.content.Context"
import "android.os.Vibrator"
import "android.widget.*"
import "android.view.Gravity"
import "com.androlua.*"
import "android.content.Intent"

context = activity or service
vibrator = context.getSystemService(Context.VIBRATOR_SERVICE)

function MostrarMenu()
  local layout = {
    LinearLayout,
    orientation = "vertical",
    padding = "16dp",
    {
      TextView,
      text = "Descarga Universal de audio.",
      textSize = "20sp",
      gravity = "center",
      padding = "8dp",
    },
    {
      EditText,
      id = "EntradaURL",
      hint = "Pega la URL aquí:",
      layout_width = "match_parent",
      layout_height = "wrap_content",
    },
    {
      Button,
      text = "Guardar.",
      onClick = function()
        local URL = tostring(EntradaURL.getText())
        if URL == "" then
          vibrator.vibrate(100)
          Toast.makeText(context, "No has ingresado una URL", Toast.LENGTH_SHORT).show()
          return
        end

        -- Siempre se descargará la lista completa si es una playlist (noplaylist = False)
        local noplaylist_val = "False"
        local plantillaPython = [[#!/usr/bin/env python
import os
import yt_dlp
from gtts import gTTS
import subprocess

def download_content(url):
    ydl_opts = {
        'format': 'bestaudio/best',
        'outtmpl': '/storage/emulated/0/Download/%%(title)s.%%(ext)s',
        'postprocessors': [{
            'key': 'FFmpegExtractAudio',
            'preferredcodec': '%s',
            'preferredquality': '%s',
        }],
        'noplaylist': %s,
        'ignoreerrors': True,
        'extract_flat': False
    }
    with yt_dlp.YoutubeDL(ydl_opts) as ydl:
        try:
            ydl.download([url])
            print("Descarga completada con éxito.")
        except Exception as e:
            print(f"Error durante la descarga: {str(e)}")

if __name__ == "__main__":
    youtube_url = "%s"
    download_content(youtube_url)
    # Actualizar la base de datos multimedia de Android
    carpeta_salida = "/storage/emulated/0/Download/"
    print("Actualizando la base de datos multimedia de Android...")
    subprocess.run([
        "am", "broadcast", "-a", "android.intent.action.MEDIA_SCANNER_SCAN_FILE",
        "-d", f"file://{carpeta_salida}"
    ], capture_output=True, text=True)
    print("Proceso completado.")
    texto = f"Descarga finalizada."
    tts = gTTS(text=texto, lang="es")
    archivo_audio = "/storage/emulated/0/Download/tts.mp3"
    tts.save(archivo_audio)  # Guardar el audio
    os.system(f"mpv {archivo_audio}")
]]
        local codigoPython = string.format(plantillaPython, "wav", "320", noplaylist_val, URL)
        local rutaArchivo = "/storage/emulated/0/Documents/descargar_yt_dlp.py"
        local archivo = io.open(rutaArchivo, "w")
        if archivo then
          archivo:write(codigoPython)
          archivo:close()
          Toast.makeText(context, "Código Python generado en Documents", Toast.LENGTH_SHORT).show()
        else
          Toast.makeText(context, "Error al escribir el archivo", Toast.LENGTH_SHORT).show()
        end
        dlg.dismiss()  -- Cierra la interfaz
      end,
      layout_width = "match_parent",
      layout_height = "wrap_content",
      padding = "16dp",
    },
  }
  dlg = LuaDialog(service)
  local view = loadlayout(layout)
  dlg.View = view
  dlg.show()
  EntradaURL.requestFocus()  -- Enfoca automáticamente el cuadro de edición
  vibrator.vibrate(100)
end

MostrarMenu()
return true